import std.stdio;
import model;
import codestream;
import backend_d;
import parser_generator;

MODEL Model()
{
  auto then_ = mkSequence
    (
      [
        mkField(4, "DWORD", "then_", 1, ""),
      ],
    );
	
  auto else_ = mkSequence
    (
      [
        mkField(4, "DWORD", "else_", 1, ""),
      ],
    );
	
  auto namedSeq_ = mkNamedSequence
    (
      "SEQ",
      [
        mkField(4, "DWORD", "seq_", 1, ""),
      ],
    );
	
  auto seq_ = mkSequence
    (
      [
        mkField(4, "DWORD", "seq_", 1, ""),
        mkFieldBits(17, "BITS", "field3_", 1, "this is a bit field"),
      ],
    );
	
  return [
	mkNamedSequence
    (
      "COMPLEX_TYPE",
      [
        mkField(4, "DWORD", "ct1_", 1, ""),
        mkField(4, "DWORD", "ct2_", 1, ""),
      ],
    ),
    mkNamedSequence
    (
      "COVERAGE_TEST",
      [
        mkField(4, "DWORD", "field_dw", 1, "this is a simple field"),
		mkFieldBits(1 , "BITS", "field_b1" , 1, "this is a  1 bit field"),
		mkFieldBits(14, "BITS", "field_b14", 1, "this is a 14 bit field"),
		mkFieldBits(65, "BITS", "field_b65", 1, "this is a 65 bit field"),
        mkField(4, "COMPLEX_TYPE", "field_cx", 1, "this is a complex field"),
		mkIf("field1 == 1", then_, else_),
		mkLoop("field1 == 1", namedSeq_),
		mkNamedSequence("NAMED_SEQ", [seq_]),
      ],
    ),
  ];
}

int main(string[] args)
{
  auto b = new Backend_D;
  auto code = getParserCode(Model(), b);
  writeln(code);
  return 0;
}
